Program flatshading;

uses crt;

const maxcol=32;  {pro vypocet a nastaveni barev}
      max_x=319;  {pro 2d clipping}
      max_y=199;
      maxpoints=1200; {to je snad jasny}
      maxpolys=900;
      xposun=(max_x+1) div 2; {posun pro prepocet 3D->2D}
      yposun=(max_y+1) div 2;
      maxsort=maxpolys div 2; {vetsinou je viditelna jen asi polovina
			       vsech polygonu}

{$I POLY.PAS}
{polygon rutine by Shakul (ya respect!!)}

type
  Virtual = Array [1..64000] of byte;
  VirtPtr = ^Virtual;                 { Pointer to virtual screen }
   SORTTYPE = RECORD
    sortlist : Array [1..maxsort,1..2] of INTEGER
  END;
  SCRCORD = RECORD  { point on screen }
    X : INTEGER;
    Y : INTEGER;
  END;
  POINT = RECORD  { Point in 3d space }
    X : INTEGER;
    Y : INTEGER;
    Z : INTEGER;
  END;
  POLYGON = RECORD
    cornerpoints : Array [1..4] of SCRCORD;
    whichpoints : Array [1..4] of INTEGER;
    zposition : INTEGER;
    shadedcolor,color : Integer;
    hidden : BOOLEAN;
    normal:point;            {normala polygonu}
    normallength:real;     {velikost normaly}
    rotnormal:point;
  END;
  _3DOBJECT = RECORD
    degreinc : POINT;
    degre : POINT;
    numberofpoints : INTEGER;
    numberofpolys : INTEGER;
    POLYs : Array [1..maxpolys] of POLYGON;
    orginalcordinates : Array [1..maxpoints] of POINT;
    rotatedcordinates : Array [1..maxpoints] of POINT;
    screencordinates : Array [1..maxpoints] of SCRCORD;
    sortdata : Sorttype;
    objpos : POINT;
  end;

TOBJECT=^_3DOBJECT;

VAR   objarr: array [1..100] of Tobject;
      sina,cosa : Array [0..360] of real;
      light : point;
      lightn: point;  {normalizovany vektor svetla}
      Virscr: VirtPtr;
      Virt1: Word;                     {Segment value of virtual screen}
      cam: point;                      {viewpoint}
      numshow:integer;                 {pocet viditelnych polygonu}


{************************************************************************}

Procedure FlipPage(source,dest:Word); Assembler;
Asm
  push    ds              { Save ds on stack }
  mov     ax,[Source]
  mov     ds,ax           { ds => source segment }
  xor     si,si           { ds:si => source }
  mov     ax,[Dest]
  mov     es,ax           { es => destination segment }
  xor     di,di           { es:di => destination }
  mov     cx,16000        { Screen size = 64 kbytes = 16000 dwords }
  db      66h
  rep     movsw           { Copy ds:si to es:di }
  pop     ds              { Restore ds }
End;

{************************************************************************}

procedure WaitRetrace; Assembler;
Asm
  mov     dx,3dah
@l1:
  in      al,dx
  and     al,08h
  jnz     @l1
@l2:
  in      al,dx
  and     al,08h
  jz      @l2
End;

{************************************************************************}

Procedure Clear(Color:Byte;Where:Word); Assembler;
Asm
  push    es
  mov     ax,Where
  mov     es,ax           { ES points to VGA or vitual screen }
  xor     di,di           { Start at begin of screen }
  cld
  mov     al,Color        { Set color in ax }
  mov     ah,al
  mov     cx,32000        { Do the entire screen }
  rep     stosw           { Store the word in ax to es:[di] }
  pop     es
end;

{************************************************************************}

Procedure Set_Color(Color,R,G,B: Byte); Assembler;
Asm
  mov     dx,03c8h
  mov     al,Color        { Load colorvalue (0..255) to alter }
  out     dx,al
  inc     dx
  mov     al,R            { Red }
  out     dx,al
  mov     al,G            { Green }
  out     dx,al
  mov     al,B            { Blue }
  out     dx,al
End;

{************************************************************************}

procedure loadobj(por:integer;name:string);
var F:text;
    i:integer;
    str:string[9];
    fac:word;
    obj:tobject;
begin
{$I-}
  assign(F,name);
  reset(F);
{$I+}
  if IOResult<>0 then
   begin
    asm
     mov ax,$3
     int 10h;
    end;
    writeln('object file doesn''t exist');
    halt(0);
   end;
  new(objarr[por]);
  obj:=objarr[por];
  obj^.numberofpoints:=0;
  i:=0;
  repeat
    inc(i);
    if i>1024 then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('this is no object file');
      dispose(obj);
      halt(0);
     end;
    readln(F,str);
    if eof(F) then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('this is no object file');
      dispose(obj);
      halt(0);
     end;
  until Str='POINTS:';
  i:=1;
  while not eoln(F) do
   begin
    read(F,obj^.orginalcordinates[i].x); {nacte body}
    read(F,obj^.orginalcordinates[i].y);
    readln(F,obj^.orginalcordinates[i].z);
    inc(i);
    if i=maxpoints then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('very much points');
      dispose(obj);
      halt(0);
     end;
   end;
  dec(i);
  obj^.numberofpoints:=i;

  i:=0;
  repeat
    inc(i);
    if i>1024 then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('this is no object file');
      dispose(obj);
      halt(0);
     end;
    readln(F,str);
    if eof(F) then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('this is no object file');
      dispose(obj);
      halt(0);
     end;
  until str='FACES:';
  i:=1;
  while not eoln(F) do
   begin
    read(F,fac);
    obj^.polys[i].whichpoints[1]:=fac;
    read(F,fac);
    obj^.polys[i].whichpoints[2]:=fac;
    readln(F,fac);
    obj^.polys[i].whichpoints[3]:=fac;
    inc(i);
    if i=maxpolys then
     begin
      asm
       mov ax,$3
       int 10h;
      end;
      writeln('very much polygons');
      dispose(obj);
      halt(0);
     end;
   end;
  dec(i);
  obj^.numberofpolys:=i;
  close(F);
  obj^.objpos.x:=0;
  obj^.objpos.y:=0;
  obj^.objpos.z:=0;
  obj^.degre.x:=0;
  obj^.degre.y:=0;
  obj^.degre.z:=0;
end;

{************************************************************************}

procedure loadobject(por:integer);
var i:integer;
 begin
  new(objarr[por]);
  objarr[por]^.objpos.x:=0;
  objarr[por]^.objpos.y:=0;
  objarr[por]^.objpos.z:=200;

  objarr[por]^.numberofpoints:=14;
  objarr[por]^.degre.x:=0;
  objarr[por]^.degre.y:=0;
  objarr[por]^.degre.z:=0;


  objarr[por]^.orginalcordinates[1].x:=0;
  objarr[por]^.orginalcordinates[1].y:=30;
  objarr[por]^.orginalcordinates[1].z:=0;

  objarr[por]^.orginalcordinates[2].x:=-20;
  objarr[por]^.orginalcordinates[2].y:=20;
  objarr[por]^.orginalcordinates[2].z:=20;

  objarr[por]^.orginalcordinates[3].x:=20;
  objarr[por]^.orginalcordinates[3].y:=20;
  objarr[por]^.orginalcordinates[3].z:=20;

  objarr[por]^.orginalcordinates[4].x:=-30;
  objarr[por]^.orginalcordinates[4].y:=0;
  objarr[por]^.orginalcordinates[4].z:=0;

  objarr[por]^.orginalcordinates[5].x:=0;
  objarr[por]^.orginalcordinates[5].y:=0;
  objarr[por]^.orginalcordinates[5].z:=30;

  objarr[por]^.orginalcordinates[6].x:=30;
  objarr[por]^.orginalcordinates[6].y:=0;
  objarr[por]^.orginalcordinates[6].z:=0;

  objarr[por]^.orginalcordinates[7].x:=-20;
  objarr[por]^.orginalcordinates[7].y:=-20;
  objarr[por]^.orginalcordinates[7].z:=20;

  objarr[por]^.orginalcordinates[8].x:=20;
  objarr[por]^.orginalcordinates[8].y:=-20;
  objarr[por]^.orginalcordinates[8].z:=20;

  objarr[por]^.orginalcordinates[9].x:=0;
  objarr[por]^.orginalcordinates[9].y:=-30;
  objarr[por]^.orginalcordinates[9].z:=0;

  objarr[por]^.orginalcordinates[10].x:=-20;
  objarr[por]^.orginalcordinates[10].y:=20;
  objarr[por]^.orginalcordinates[10].z:=-20;

  objarr[por]^.orginalcordinates[11].x:=20;
  objarr[por]^.orginalcordinates[11].y:=20;
  objarr[por]^.orginalcordinates[11].z:=-20;

  objarr[por]^.orginalcordinates[12].x:=0;
  objarr[por]^.orginalcordinates[12].y:=0;
  objarr[por]^.orginalcordinates[12].z:=-30;

  objarr[por]^.orginalcordinates[13].x:=-20;
  objarr[por]^.orginalcordinates[13].y:=-20;
  objarr[por]^.orginalcordinates[13].z:=-20;

  objarr[por]^.orginalcordinates[14].x:=20;
  objarr[por]^.orginalcordinates[14].y:=-20;
  objarr[por]^.orginalcordinates[14].z:=-20;


  objarr[por]^.numberofpolys:=24;

  objarr[por]^.polys[1].whichpoints[1]:=1;
  objarr[por]^.polys[1].whichpoints[2]:=2;
  objarr[por]^.polys[1].whichpoints[3]:=3;

  objarr[por]^.polys[2].whichpoints[1]:=1;
  objarr[por]^.polys[2].whichpoints[2]:=3;
  objarr[por]^.polys[2].whichpoints[3]:=11;

  objarr[por]^.polys[3].whichpoints[1]:=1;
  objarr[por]^.polys[3].whichpoints[2]:=11;
  objarr[por]^.polys[3].whichpoints[3]:=10;

  objarr[por]^.polys[4].whichpoints[1]:=1;
  objarr[por]^.polys[4].whichpoints[2]:=10;
  objarr[por]^.polys[4].whichpoints[3]:=2;

  objarr[por]^.polys[5].whichpoints[1]:=2;
  objarr[por]^.polys[5].whichpoints[2]:=5;
  objarr[por]^.polys[5].whichpoints[3]:=3;

  objarr[por]^.polys[6].whichpoints[1]:=3;
  objarr[por]^.polys[6].whichpoints[2]:=6;
  objarr[por]^.polys[6].whichpoints[3]:=11;

  objarr[por]^.polys[7].whichpoints[1]:=11;
  objarr[por]^.polys[7].whichpoints[2]:=12;
  objarr[por]^.polys[7].whichpoints[3]:=10;

  objarr[por]^.polys[8].whichpoints[1]:=10;
  objarr[por]^.polys[8].whichpoints[2]:=4;
  objarr[por]^.polys[8].whichpoints[3]:=2;

  objarr[por]^.polys[9].whichpoints[1]:=2;
  objarr[por]^.polys[9].whichpoints[2]:=7;
  objarr[por]^.polys[9].whichpoints[3]:=5;

  objarr[por]^.polys[10].whichpoints[1]:=3;
  objarr[por]^.polys[10].whichpoints[2]:=5;
  objarr[por]^.polys[10].whichpoints[3]:=8;

  objarr[por]^.polys[11].whichpoints[1]:=3;
  objarr[por]^.polys[11].whichpoints[2]:=8;
  objarr[por]^.polys[11].whichpoints[3]:=6;

  objarr[por]^.polys[12].whichpoints[1]:=11;
  objarr[por]^.polys[12].whichpoints[2]:=6;
  objarr[por]^.polys[12].whichpoints[3]:=14;

  objarr[por]^.polys[13].whichpoints[1]:=11;
  objarr[por]^.polys[13].whichpoints[2]:=14;
  objarr[por]^.polys[13].whichpoints[3]:=12;

  objarr[por]^.polys[14].whichpoints[1]:=10;
  objarr[por]^.polys[14].whichpoints[2]:=12;
  objarr[por]^.polys[14].whichpoints[3]:=13;

  objarr[por]^.polys[15].whichpoints[1]:=10;
  objarr[por]^.polys[15].whichpoints[2]:=13;
  objarr[por]^.polys[15].whichpoints[3]:=4;

  objarr[por]^.polys[16].whichpoints[1]:=2;
  objarr[por]^.polys[16].whichpoints[2]:=4;
  objarr[por]^.polys[16].whichpoints[3]:=7;

  objarr[por]^.polys[17].whichpoints[1]:=7;
  objarr[por]^.polys[17].whichpoints[2]:=9;
  objarr[por]^.polys[17].whichpoints[3]:=8;

  objarr[por]^.polys[18].whichpoints[1]:=8;
  objarr[por]^.polys[18].whichpoints[2]:=9;
  objarr[por]^.polys[18].whichpoints[3]:=14;

  objarr[por]^.polys[19].whichpoints[1]:=14;
  objarr[por]^.polys[19].whichpoints[2]:=9;
  objarr[por]^.polys[19].whichpoints[3]:=13;

  objarr[por]^.polys[20].whichpoints[1]:=13;
  objarr[por]^.polys[20].whichpoints[2]:=9;
  objarr[por]^.polys[20].whichpoints[3]:=7;

  objarr[por]^.polys[21].whichpoints[1]:=5;
  objarr[por]^.polys[21].whichpoints[2]:=7;
  objarr[por]^.polys[21].whichpoints[3]:=8;

  objarr[por]^.polys[22].whichpoints[1]:=6;
  objarr[por]^.polys[22].whichpoints[2]:=8;
  objarr[por]^.polys[22].whichpoints[3]:=14;

  objarr[por]^.polys[23].whichpoints[1]:=12;
  objarr[por]^.polys[23].whichpoints[2]:=14;
  objarr[por]^.polys[23].whichpoints[3]:=13;

  objarr[por]^.polys[24].whichpoints[1]:=4;
  objarr[por]^.polys[24].whichpoints[2]:=13;
  objarr[por]^.polys[24].whichpoints[3]:=7;

  for i:= 1 to 24 do objarr[por]^.polys[i].color:=8;
END;

{************************************************************************}

Procedure initcolors;
var
 i:integer;
begin
  for i:=0 to maxcol do
   begin
    Set_Color(i,i,i,i);
   end;
end;

{************************************************************************}

procedure initfirst;
var i:integer;
begin
  GetMem(VirScr,64000);
  Virt1:= Seg(VirScr^);
  asm
   mov ax,$13
   int 10h
  end;
  for i:=0 to 360 do begin
    sina[i]:=sin(i*pi/180); {*/180 converts it to radians which the computer
     calculed in don't think more about this}
    cosa[i]:=cos(i*pi/180);
  end;
  initcolors;
end;

{************************************************************************}

{inicualuzeje normaly polygonu a svetlo}
procedure initl_and_n(obj:tobject);
var
    i:integer;
    ux,uy,uz,vx,vy,vz:integer;
    pomnormx,pomnormy,pomnormz:real;
    nnormx,nnormy,nnormz:real;
    lengthpn:real; {velikost normaly polygonu}
    a,b,c:longint; {pomocne prom. na vypocet norm. svetla}
    lightlength:real;

begin
  light.x:=0;
  light.y:=0;
  light.z:=-1;
    {velikost normaly svetla}
    a:=longint(light.x)*longint(light.x);
    b:=longint(light.y)*longint(light.y);
    c:=longint(light.z)*longint(light.z);
    lightlength:=sqrt(a+b+c);
    if lightlength=0 then lightlength:=0.01;
    {normalizace normaly svetla}
    lightn.x:=round(light.x/lightlength);
    lightn.y:=round(light.y/lightlength);
    lightn.z:=round(light.z/lightlength);
  for i:=1 to obj^.Numberofpolys do
   begin
    ux:=obj^.orginalcordinates[obj^.polys[i].whichpoints[2]].x-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].x;
    vx:=obj^.orginalcordinates[obj^.polys[i].whichpoints[3]].x-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].x;
    uy:=obj^.orginalcordinates[obj^.polys[i].whichpoints[2]].y-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].y;
    vy:=obj^.orginalcordinates[obj^.polys[i].whichpoints[3]].y-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].y;
    uz:=obj^.orginalcordinates[obj^.polys[i].whichpoints[2]].z-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].z;
    vz:=obj^.orginalcordinates[obj^.polys[i].whichpoints[3]].z-obj^.orginalcordinates[obj^.polys[i].whichpoints[1]].z;
    pomnormx:=(uy*vz-uz*vy);     {normala nenormalizovana}
    pomnormy:=(uz*vx-ux*vz);
    pomnormz:=(ux*vy-uy*vx);
    {delka nenormalizovane normaly}
    lengthpn:=(sqrt(pomnormx*pomnormx+pomnormy*pomnormy+pomnormz*pomnormz));
    if lengthpn=0 then lengthpn:=0.01;
    {konecna uprava normaly polygonu}
    nnormx:=pomnormx/(lengthpn*lightlength);
    nnormy:=pomnormy/(lengthpn*lightlength);
    nnormz:=pomnormz/(lengthpn*lightlength);
    {vynasobeni max colorem}
    obj^.polys[i].normal.x:=round(nnormx*maxcol);
    obj^.polys[i].normal.y:=round(nnormy*maxcol);
    obj^.polys[i].normal.z:=round(nnormz*maxcol);
   end;
end;

{************************************************************************}

{upravi uhel o kolik rotovat}
procedure  uppgradeobject(obj:tobject);
begin
  inc(obj^.degre.x,obj^.degreinc.x);
  inc(obj^.degre.y,obj^.degreinc.y);
  inc(obj^.degre.z,obj^.degreinc.z);
  if obj^.degre.x<0 then inc(obj^.degre.x,360);
  if obj^.degre.x>360 then dec(obj^.degre.x,360);
  if obj^.degre.y<0 then inc(obj^.degre.y,360);
  if obj^.degre.y>360 then dec(obj^.degre.y,360);
  if obj^.degre.z<0 then inc(obj^.degre.z,360);
  if obj^.degre.z>360 then dec(obj^.degre.z,360);
end;

{************************************************************************}

{prevede object ze 3D do 2D}
procedure perspective(obj:tobject);
var i:INTEGER;
   dist:real;
   xx,yy:longint;
begin
  for i:= 1 to obj^.numberofpoints do begin
    dist:=obj^.rotatedcordinates[i].z+cam.z;
    xx:=longint(obj^.rotatedcordinates[i].x);
    yy:=-(longint(obj^.rotatedcordinates[i].y));
    obj^.screencordinates[i].x:=xposun+round(xx*256/dist);
    obj^.screencordinates[i].y:=yposun+round(yy*256/dist);
  end;
end;

{************************************************************************}

{painter's algoritm, vypocet barvy polygonu}
procedure readin(obj:tobject);

Var
    a,i,b : integer;
    dotpr:longint;
    col2:integer;
    l1,l2,l3:integer;
    poma,pomb,pomc,pomd:integer;
    nz:longint;

begin
  numshow:=0;  {pocet viditelnych polygonu}
  for i:= 1 to obj^.numberofpolys do
   begin
     a:=0;
     for b:= 1 to 3 do
      begin
       a:=a+obj^.rotatedcordinates[obj^.polys[i].whichpoints[b]].z;
       obj^.polys[i].cornerpoints[b]:= obj^.screencordinates[obj^.polys[i].whichpoints[b]];
      end;
    a:=a div 3;  {prumer z souradnic polygonu}
    obj^.polys[i].zposition:=a;


    l1:=obj^.polys[i].whichpoints[1];
    l2:=obj^.polys[i].whichpoints[2];
    l3:=obj^.polys[i].whichpoints[3];

    poma:=(obj^.screencordinates[l1].y-obj^.screencordinates[l2].y);
    pomb:=(obj^.screencordinates[l3].x-obj^.screencordinates[l2].x);
    pomc:=(obj^.screencordinates[l1].x-obj^.screencordinates[l2].x);
    pomd:=(obj^.screencordinates[l3].y-obj^.screencordinates[l2].y);

    nz:=poma*pomb-pomc*pomd;     {napsano podle ELova tutorialu
                                  face remove udelanej takle a facha!}

    if nz>0 then {dale pocitam jen pro viditelne - zvetseni rychlosi!!!}
      begin
       inc(numshow);
       {dulezite na druhou pozici sortlistu uloz prumer z souradnic}
       {na prvni pozici cislo polygonu, tady to musi byt postupne od 1 do 12
       jinak to nepude!!}

       obj^.sortdata.sortlist[numshow,2]:=obj^.polys[i].zposition;
       obj^.sortdata.sortlist[numshow,1]:=i;
       {skalarni soucin svetlo normala polygonu, hazi uz rovnou barvu
       v dusledku upravy normaly v proc. init}

       dotpr:=(obj^.polys[i].rotnormal.x*lightn.x
               +obj^.polys[i].rotnormal.y*lightn.y
               +obj^.polys[i].rotnormal.z*lightn.z);

       col2:=(dotpr);
       if col2<0  then col2:=0;
       if col2>maxcol then col2:=maxcol;
       obj^.polys[i].shadedcolor:=col2;
       obj^.polys[i].hidden:=false;        {polygon je viditelny}
      end
     else obj^.polys[i].hidden:=true;     {neni videt}
   end;
end;

{************************************************************************}

{to je snad jasny}
Procedure QUICKSORT(lo,hi :INTEGER;var world:SORTTYPE);

Procedure LORT(l,r : INTEGER; Var World : SORTTYPE);

var i,j,x,y : INTEGER;

begin
  i:=l;
  j:=r;
  x:=world.sortlist[(l+r) shr 1,2];
  repeat
    while world.sortlist[i,2]<x do inc(i);
    while x<world.sortlist[j,2] do dec(j);
    if i<=j then begin
      y:=world.sortlist[i,1];
      world.sortlist[i,1]:=world.sortlist[j,1];
      world.sortlist[j,1]:=y;
      y:=world.sortlist[i,2];
      world.sortlist[i,2]:=world.sortlist[j,2];
      world.sortlist[j,2]:=y;
      inc(i);
      dec(j)
    end
  until i>j;
  if l<j then lort(l,j,world);
  if i<r then lort(i,r,world)
end;

begin
  lort(lo,hi,world)
end;

{************************************************************************}

{setridi podle Z a vykresli vsechny polygony objectu}
procedure putpolys(obj:tobject;where:word);

var i : INTEGER;
    x1,x2,y1,y2,x3,y3:integer;
    col:byte;
    cispol:integer;
begin
  quicksort (1,numshow,obj^.sortdata);
  for i:= numshow downto 1 do
   begin
    cispol:=obj^.sortdata.sortlist[i,1];   {cislo setrideneho polygonu}
    if obj^.polys[cispol].hidden=false then {je videt ci ne?}
     begin
      x1:=obj^.polys[cispol].cornerpoints[1].x;
      y1:=obj^.polys[cispol].cornerpoints[1].y;
      x2:=obj^.polys[cispol].cornerpoints[2].x;
      y2:=obj^.polys[cispol].cornerpoints[2].y;
      x3:=obj^.polys[cispol].cornerpoints[3].x;
      y3:=obj^.polys[cispol].cornerpoints[3].y;
      col:=obj^.polys[cispol].shadedcolor;
      POLYGONFILL(x1,y1,x2,y2,x3,y3,col,virt1); {VERY FAAAAAST!!!!!!}
    end;
   end;
end;

{************************************************************************}

{rotace vsech bodu a normal vsech polygonu}
Procedure ZXYROUT(obj:tobject);

Var a,b,c,d,e,f,g,h,j : REAL;
    i : INTEGER;

Begin
  a:=cosa[obj^.degre.y]*cosa[obj^.degre.z];
  b:=cosa[obj^.degre.y]*sina[obj^.degre.z];
  c:=-sina[obj^.degre.y];
  d:=sina[obj^.degre.x]*sina[obj^.degre.y]*cosa[obj^.degre.z]-cosa[obj^.degre.x]*sina[obj^.degre.z];
  e:=sina[obj^.degre.x]*sina[obj^.degre.y]*sina[obj^.degre.z]+cosa[obj^.degre.x]*cosa[obj^.degre.z];
  f:=sina[obj^.degre.x]*cosa[obj^.degre.y];
  g:=cosa[obj^.degre.x]*sina[obj^.degre.y]*cosa[obj^.degre.z]+sina[obj^.degre.x]*sina[obj^.degre.z];
  h:=cosa[obj^.degre.x]*sina[obj^.degre.y]*sina[obj^.degre.z]-sina[obj^.degre.x]*cosa[obj^.degre.z];
  j:=cosa[obj^.degre.x]*cosa[obj^.degre.y];
  for i:= 1 to obj^.numberofpoints do begin
    obj^.rotatedcordinates[i].x :=round( obj^.objpos.x+obj^.orginalcordinates[i].x*a+obj^.orginalcordinates[i].y*b
    +obj^.orginalcordinates[i].z*c);
    obj^.rotatedcordinates[i].y :=round( obj^.objpos.y+obj^.orginalcordinates[i].x*d+obj^.orginalcordinates[i].y*e
    +obj^.orginalcordinates[i].z*f);
    obj^.rotatedcordinates[i].z :=round( obj^.objpos.z+obj^.orginalcordinates[i].x*g+obj^.orginalcordinates[i].y*h
    +obj^.orginalcordinates[i].z*j);
  end;
  for i:= 1 to obj^.numberofpolys do    {rotace normal-vertoru}
   begin
    obj^.polys[i].rotnormal.x:=round(obj^.polys[i].normal.x*a+obj^.polys[i].normal.y*b
    +obj^.polys[i].normal.z*c);
    obj^.polys[i].rotnormal.y:=round(obj^.polys[i].normal.x*d+obj^.polys[i].normal.y*e
    +obj^.polys[i].normal.z*f);
    obj^.polys[i].rotnormal.z:=round(obj^.polys[i].normal.x*g+obj^.polys[i].normal.y*h
    +obj^.polys[i].normal.z*j);
   end;

end;

{************************************************************************}

{tady je to vsechno v kupe}
procedure rotflat(por,ax,ay,az:integer;where:word);

begin
 objarr[por]^.degreinc.x:=ax;
 objarr[por]^.degreinc.y:=ay;
 objarr[por]^.degreinc.z:=az;
 uppgradeobject(objarr[por]);
 zxyrout(objarr[por]);
 perspective(objarr[por]);
 readin(objarr[por]);
 putpolys(objarr[por],virt1);
end;

{************************************************************************}

{navrat do textaku a uvolneni pameti}
procedure Close;
begin
 FreeMem(VirScr,64000);
 asm
  mov ax,$3
  int 10h
 end;
end;

{************************************************************************}

{uvolni object z pameti}
procedure freeobj(por:integer);
begin
 dispose(objarr[por]);
end;

{************************************************************************}

begin
 if paramstr(1)='' then
  begin
   writeln('Usage: objeng <file.xyz>' );
   halt(0);
  end;
 initfirst;
 {loadobject(1);}
 cam.x:=0;
 cam.y:=0;
 cam.z:=300;
 loadobj(1,paramstr(1));
 initl_and_n(objarr[1]);
 clear(0,virt1);
 repeat
  begin
   rotflat(1,1,2,1,virt1);
   waitretrace;
   flippage(virt1,$a000);
   clear(0,virt1);
  end;
 until keypressed;
 freeobj(1);
 close;
end.
